// Виджет корзины 
ShopReduxReducer.prototype.HandleBasketWidget = (state, action) => {

	state.showBasketWidget = action.show

	return state

}

ShopAppFactory.HandleBasketWidget = (show = null) => {

	if (null === show) return ShopReduxStore.getState().showBasketWidget || false

	if (show) ShopAppFactory.DataLayer('store-backetbag')

	ShopReduxStore.dispatch({ type: 'HandleBasketWidget', show })

}

// Страница-раздел магазина
ShopReduxReducer.prototype.SetShopPage = (state, action) => {

	state.page = action.pg

	return state

}

ShopAppFactory.GetShopPage = () => {

	const state = ShopReduxStore.getState()

	if ('checkout' == $(location).prop('hash').substr(1) && 'undefined' === typeof state.page)
		ShopReduxStore.dispatch({ type: 'SetShopPage', pg: 'checkout' })

	return 'string' === typeof state.page ? state.page : 'store'

}

ShopAppFactory.SetShopPage = pg => { ShopReduxStore.dispatch({ type: 'SetShopPage', pg }) }

// Tabs в разделе Store
ShopAppFactory.GetStoreTab = tab => {

	const state = ShopReduxStore.getState()

	return 'undefined' === typeof state.storeTabs || 'undefined' === typeof state.storeTabs[tab] ? 0 : state.storeTabs[tab]

}

ShopReduxReducer.prototype.SetStoreTab = (state, action) => {

	if ('undefined' === typeof state.storeTabs) state['storeTabs'] = { top: 0, bottom: 0 }

	state.storeTabs[action.val.typeTab] = action.val.tab

	if ('top' == action.val.typeTab) state.storeTabs.bottom = 0

	return state

}

ShopAppFactory.SetStoreTab = (typeTab, tab) => { ShopReduxStore.dispatch({ type: 'SetStoreTab', val: { typeTab, tab } }) }

// Управление цветом 
ShopReduxReducer.prototype.SetColorItem = (state, action) => {

	if ('undefined' === typeof state['itemColor']) state['itemColor'] = {}

	state.itemColor[action.color.parent] = { id: action.color.id, color: action.color.color }

	return state

}

ShopAppFactory.SetColorItem = (parent, id, color) => { ShopReduxStore.dispatch({ type: 'SetColorItem', color: { parent, id, color } }) }

ShopAppFactory.GetColorItem = id => {

	const state = ShopReduxStore.getState()

	return 'undefined' === typeof state.itemColor || 'undefined' === typeof state.itemColor[id] ? null : state.itemColor[id]

}


// Обработка формата цены 
ShopAppFactory.PriceHelper = (prices, local, c = true) => {

	let price = 'object' === typeof prices ? prices[local] : prices,
		curr = c ? p => {

			switch (local) {

				case 'ru': return String(p) + ' ₽'

				case 'us': return '$' + String(p)

			}

		} : p => p

	switch (local) {

		case 'ru': return curr(String(price).replace(/(\d)(?=(\d\d\d)+([^\d]|$))/g, '$1 '))

		case 'us':

			price = String(price).split('.')

			price[1] = price[1] || '00'
  
		return curr(price[0].replace(/(\d)(?=(\d\d\d)+([^\d]|$))/g, '$1,')) + '.' + price[1]

		default: return price;

	}

}

// Диалоговое окно 
ShopReduxReducer.prototype.DeliveryDialog = (state, action) => {

	state.deliveryDialog = action.set

	return state

}

ShopAppFactory.DeliveryDialog = action => {

	if ('get' == action) {

		const state = ShopReduxStore.getState()

		return 'undefined' === typeof state.deliveryDialog ? false : state.deliveryDialog

	} else
		ShopReduxStore.dispatch({ type: 'DeliveryDialog', set: action })

}

// Валидация E-Mail
ShopAppFactory.EmailValidations = mail => {

	const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

	return pattern.test(mail);

}

/* Добавление удаление товаров и их количества */

// Получить список товаров положеных в корзину
ShopAppFactory.GetProduct = () => {

	const state = ShopReduxStore.getState()

	if ('undefined' !== typeof state.basket)
		return state.basket

	let cookie = $.cookie('state_basket')

	if ('string' === typeof cookie && '' != cookie && '{}' != cookie)
		return JSON.parse(cookie)

	return {}

}

// Добавление, удаление товаров в корзине
ShopReduxReducer.prototype.SetProduct = (state, { obj }) => {

	let { id, action, count } = obj, cookie = $.cookie('state_basket'), { basket } = state

	if ('undefined' === typeof basket) basket = 'string' === typeof cookie && '' != cookie && '{}' != cookie ? JSON.parse(cookie) : {}

	switch (action) {

		case 'add':

			let newCount = ('number' === typeof basket[id] ? basket[id] : 0) + count

			if (newCount < 0) newCount = 0

			basket[id] = newCount

			break;

		case 'set': basket[id] = count; break;

		case 'clear': basket = []; break;

	}

	$.cookie('state_basket', JSON.stringify(basket), { expires: 7, path: '/' });

	state.promoReload = true

	state.basket = basket

	return state

}

// Добавление, удаление товаров в корзине
ShopAppFactory.SetProduct = (act, id = 0, count = 0) => {

	id = parseInt(id)

	ShopReduxStore.dispatch({ type: 'SetProduct', obj: { action: act, id, count } })

}

// Получение данных виджета корзины
ShopAppFactory.GetDataWidget = (getNull = false) => {

	let idsCounts = ShopAppFactory.GetProduct()

	if ('{}' === JSON.stringify(idsCounts)) return null;

	let data = [],
		total = 0,
		correctionTotal = 0,
		correction = {},
		totalCount = 0,
		local = widgeData.local,
		productData = ShopData.products

	for (let id in idsCounts) {

		let count = idsCounts[id], obj = productData[id]

		if ((0 == count && !getNull) || 'undefined' === typeof obj) continue;

		if ('undefined' === typeof obj.parent) {

			let price = obj.prices[local] * count

			total += price

			totalCount += count

			data.push({
				id: id,
				title: obj.titles[local],
				color: obj.attrs.color || '',
				type: obj['type-product'],
				img: obj['cart-widget-img'],
				price: price,
				cost: obj.prices[local],
				count: count
			})

		} else {

			let parent = productData[obj.parent], price = parent.prices[local] * count

			total += price

			totalCount += count

			data.push({
				id: id,
				title: parent.titles[local],
				color: obj.attrs.color || '',
				type: obj['type-product'],
				img: obj['cart-widget-img'],
				price: price,
				cost: parent.prices[local],
				count: count
			})

		}
	}

	correctionTotal = total

	const shippungTax = ShopAppFactory.GetShippungTax(total)

	if ('{}' != JSON.stringify(shippungTax)) {

		for (let payType in shippungTax) {

			let st = shippungTax[payType]

			correctionTotal += st.val

			correction[payType] = st

		}

	}

	const promoCode = ShopAppFactory.PromoCode()

	let discount = 0

	if ('' != promoCode.promo) {

		discount = parseFloat(promoCode.obj.new_price) - total

		correctionTotal += discount

	}

	let { promoReload } = ShopReduxStore.getState()

	promoReload = promoReload || false

	return { total, correctionTotal, correction, count: totalCount, data, discount, promoReload }

}

// Верхнее меню в чекауте
ShopReduxReducer.prototype.CheckoutTabs = (state, action) => {

	state.checkoutTab = action.tab

	return state

}

// Верхнее меню в чекауте
ShopAppFactory.CheckoutTabs = (act, tab) => {

	if ('get' == act) {

		const { checkoutTab } = ShopReduxStore.getState()

		return 'number' === typeof checkoutTab ? checkoutTab : 1

	}

	const ch = () => {

		const products = ShopAppFactory.GetProduct()

		for (let i in products) if (0 < products[i]) return true

		return false

	}

	if (1 == tab || (2 == tab && ch()) || (3 == tab && ch() && null !== ShopAppFactory.getCDEK()))
		ShopReduxStore.dispatch({ type: 'CheckoutTabs', tab })

}

// Проверка предзаказа
ShopReduxReducer.prototype.PreOrder = (state, { id }) => {

	if ('undefined' === typeof state.PreOrder) state.PreOrder = []

	state.PreOrder.push(parseInt(id))

	return state

}

ShopAppFactory.PreOrder = (id = null) => {

	if (id == null) {

		let { PreOrder } = ShopReduxStore.getState()

		return PreOrder

	}

	ShopReduxStore.dispatch({ type: 'PreOrder', id })

}

// Промокоды
ShopReduxReducer.prototype.PromoCode = (state, action) => {

	state.promoCode = action.set

	state.promoReload = false

	return state

}

// Промокоды
ShopAppFactory.PromoCode = (promo = '', obj = null) => {

	if (promo == '' && obj == null)
		return ShopReduxStore.getState().promoCode || { promo: '', obj: {} }

	$.get('/getcarts?v=1', json => {

		let items = [], { products } = ShopData

		obj.items.map(v => {

			let { sku: j_sku } = json[v.id]

			for (let id in products) {

				let { sku } = products[id].attrs

				if ('string' === typeof sku && sku == j_sku) {

					v.id = id

					items.push(v)

				}

			}

			obj.items = items

			console.log(obj)

			ShopReduxStore.dispatch({ type: 'PromoCode', set: { promo, obj } })

		})

	})

}

// Промокоды, отмена
ShopAppFactory.SkipPromoCode = () => {

	ShopReduxStore.dispatch({ type: 'PromoCode', set: { promo: '', price: 0, newPrice: 0, diff: 0 } })

}

// Рассчет доставок и налогов
ShopAppFactory.GetShippungTax = total => {

	const { local } = ShopPageData

	if (local == 'ru') {

		const cdek = ShopAppFactory.getCDEK()

		return total < 3000 && null != cdek ? { shipping: { payType: 'shipping', meta: 'cdek', val: cdek.tariff.delivery_sum } } : {}

	} else {

		let data = {}

		const shippingTax = ShopData.ship_tax

		for (let id in shippingTax) {

			let item = shippingTax[id],
				payType = item['pay-type'] || 'shipping',
				sumType = item['type-sum'] || 'sum',
				condition = '<' == item['if-then'].value,
				val = parseFloat(item.shipping),
				meta = item.meta


			if (condition && 'string' === typeof item.amount && '' != item.amount) {

				let amount = parseFloat(item.amount)

				if (total < amount && val) data[payType] = { payType, meta, val }

			}

		}

		return data

	}

}

/**
 *  СДЕК
 */


ShopReduxReducer.prototype.CDEK = (state, { set: { t, data } }) => {

	if ('undefined' === typeof state.CDEK) state.CDEK = {}

	state.CDEK[t] = data

	return state

}

if ('function' === typeof CDEKWidget)
	ShopReduxStore.dispatch({
		type: 'CDEK', set: {
			t: 'widget',
			data: new CDEKWidget({
				from: 'Москва',
				root: 'cdek-map',
				apiKey: '4b82b943-b3e5-41ca-8dfb-1ac89d695711',
				canChoose: true,
				servicePath: '/staging/wp-content/themes/healbe/inc/cdek/service.php',
				hideFilters: { have_cashless: true, have_cash: true, is_dressing_room: true, type: false },
				hideDeliveryOptions: { office: false, door: false },
				popup: true,
				debug: false,
				goods: [],
				defaultLocation: [37.76, 55.77],
				lang: 'rus',
				currency: 'RUB',
				tariffs: { office: [234, 136, 138], door: [233, 137, 139] },
				onChoose(type, tariff, address) {

					ShopReduxStore.dispatch({ type: 'CDEK', set: { t: 'data', data: { type, tariff, address } } })

					this.close()

				}
			})
		}
	})


ShopAppFactory.getWidgetCDEK = () => ShopReduxStore.getState().CDEK.widget

ShopAppFactory.getCDEK = () => {

	const { CDEK } = ShopReduxStore.getState()

	return 'undefined' === typeof CDEK || 'undefined' === typeof CDEK.data ? null : CDEK.data

}

// Шаг 3, форма оплаты
ShopReduxReducer.prototype.PayForm = (state, action) => {

	const obj = action.set

	if ('undefined' === typeof state.payForm) state.payForm = obj.def

	if (obj.valid) state.payForm.valid[obj.id] = obj.val


	else {

		if ('phonePref' == obj.id || 'payType' == obj.id || 'tinkoff' == obj.id || 'comment' == obj.id)
			state.payForm[obj.id] = obj.val

		else {

			state.payForm.inps[obj.id] = obj.val

			state.payForm.valid[obj.id] = true

		}

	}

	return state

}

// Шаг 3, форма оплаты
ShopAppFactory.PayForm = (id = null, val = null, valid = false) => {

	const def = () => {

		let ids = ['name', 'sName', 'mail', 'phone'],
			d = { tinkoff: 1, phonePref: '+7', payType: 'cp', comment: '', inps: {}, valid: {} }

		ids.map(id => {

			d.inps[id] = ''

			d.valid[id] = true

		})

		return d

	}

	if (null === id || null === val) {

		const { payForm } = ShopReduxStore.getState()

		return payForm || def()

	}

	ShopReduxStore.dispatch({ type: 'PayForm', set: { id, val, valid, def: def() } })

}


// Тинькофф рассрочка
ShopAppFactory.Tinkoff = () => {

	const { T_DATA, inps, correctionTotal, data, promoCode, tinkoff_PR } = AppHelper.TransactionData(),
		{ name, sName, mail, phone } = inps, { promo, obj } = promoCode

	let items = []

	data.map(promo == '' ? ({ title, color, cost, count }) => {

		items.push({ name: title + ('' == color ? '' : ' ' + color), quantity: count, price: parseFloat(cost) })

	} : ({ id, title, color, count }) => {

		let { new_price } = obj.items.find(f => { if (id == f.id) return f.new_price })

		items.push({ name: title + ('' == color ? '' : ' ' + color), quantity: count, price: parseFloat(new_price) })

	})

	let BackOfficeData = T_DATA

	BackOfficeData.country_code = 'RU'

	BackOfficeData.order = String(Date.now()) + '_' + tinkoff_PR

	AppHelper.BackOffice(BackOfficeData, () => {

		tinkoff.create({
			shopId: '5ca7e775-b092-450e-9ed5-2980593f59ce',
			showcaseId: '366621e6-f227-422c-9e8d-d85470059978',
			orderNumber: T_DATA.order,
			promoCode: tinkoff_PR == '6' ? 'installment_0_0_6_7' : 'installment_0_0_12_15,59',
			items,
			sum: correctionTotal,
			values: { contact: { fio: { firstName: name, lastName: sName }, mobilePhone: phone, email: mail } }
		})

	})

}

// Оплата картой https://developers.cloudpayments.ru/#testirovanie
ShopAppFactory.CloudPayment = () => {

	const { T_ID, T_DATA, inps, correctionTotal } = AppHelper.TransactionData(),
		{ mail } = inps,
		{ SetShopPage, SetProduct } = ShopAppFactory,
		W = new cp.CloudPayments({
			language: 'ru-RU',
			email: mail,
			applePaySupport: false,
			googlePaySupport: false,
			yandexPaySupport: false,
			tinkoffInstallmentSupport: false,
		})

	let BackOfficeData = T_DATA

	BackOfficeData.country_code = 'RU'

	AppHelper.BackOffice(BackOfficeData, () => {

		W.pay('auth',
			{
				publicId: 'pk_2c4dfd85a816196cdaad23d02bfb1',
				amount: correctionTotal,
				currency: 'RUB',
				invoiceId: T_ID,
				email: mail,
				skin: 'modern',
				retryPayment: false,
				requireEmail: true,
				description: 'Оплата товаров в healbe.com/ru/shop/',
				data: T_DATA
			},
			{
				onComplete: ({ success }) => {

					if (success) {

						SetShopPage('succses_done')

						SetProduct('clear')

					}

				}

			})

	})

}

ShopAppFactory.Cash = () => {

	const { SetShopPage, SetProduct } = ShopAppFactory

	let { T_DATA: BackOfficeData } = AppHelper.TransactionData()

	BackOfficeData.country_code = 'RU'

	AppHelper.BackOffice(BackOfficeData, () => {

		SetShopPage('succses_done')

		SetProduct('clear')

	})

}

// Ивенты в сторе
ShopAppFactory.DataLayer = event => {

	if ('undefined' === typeof window.dataLayer)
		window.dataLayer = [];

	if ('string' === typeof event)
		window.dataLayer.push({ event });

}

